#include <autoconf.h>

	.global arch_boost_on
arch_boost_on:
	stmdb	sp!, {r0, r5}
	mov	r5, r0
	mov	r0, #0
	mcr	p15, 0, r0, c7, c7
	mcr	p15, 0, r0, c7, c10, 4
	mcr	p15, 0, r0, c8, c7
	mcr	p15, 0, r5, c2, c0
	mov	r0, #0x03
	mcr	p15, 0, r0, c3, c0

	/* CP15:cr1 Control register
	 *     M[ 0]: MMU Enable
	 *     C[ 2]: D-Cache Enable
	 *     W[ 3]: Write-buffer Enable
	 *     Z[11]: Bredict Enable
	 *     I[12]: I-Cache Enable
	 *     V[13]: High-vector */
	mrc	p15, 0, r0, c1, c0
	orr	r0, r0, #0x3800
	orr	r0, r0, #0x000d
#if defined(CONFIG_CPU_IMX31)
	orr	r0, r0, #(1 << 31)
#endif
	mcr	p15, 0, r0, c1, c0

	ldmia	sp!, {r0, r5}
	bx	lr

	.global arch_boost_off
arch_boost_off:
	stmdb	sp!, {r0, r1, lr}
	mov	r0, #0
#if defined(CONFIG_CPU_IMX31)
	mcr	p15, 0, r0, c7, c14, 0	/* D cache clean+invalidate */
	mcr	p15, 0, r0, c7, c10, 4	/* drain write buffer */
#elif defined(CONFIG_CPU_NS9750) || defined(CONFIG_CPU_IMX25)
1:	mrc	p15, 0, r15, c7, c14, 3	/* D cache:                */
	bne	1b			/*   test+clean+invalidate */
#elif defined(CONFIG_CPU_EP93XX)
	mov	r1, #7 << 5
1:	orr	r0, r1, #63 << 26
2:	mcr	p15, 0, r0, c7, c14, 2
	subs	r0, r0, #1 << 26
	bcs	2b
	subs	r1, r1, #1 << 5
	bcs	1b
	mov	r0, #0
#endif

#if defined(CONFIG_ARCH_ARM_V6)
	bl	v6_icache_inval_all
#endif

	mrc	p15, 0, r0, c1, c0, 0	/* ctrl register */
	bic	r0, r0, #0x05
	bic	r0, r0, #0x1000
#if defined(CONFIG_CPU_IMX31)
	bic	r0, r0, #0x80000000
#endif
	mcr	p15, 0, r0, c1, c0, 0	/* disable caches */

	ldmia	sp!, {r0, r1, lr}
	bx	lr

#if defined(CONFIG_ARCH_ARM_V6)
	.global v6_icache_inval_all
v6_icache_inval_all:
	stmdb	sp!, {r0, r1}
	mov	r0, #0
	mrs	r1, cpsr
	mcr	p15, 0, r0, c7, c5, 0	/* invalidate entire I-cache */
	mcr	p15, 0, r0, c7, c5, 0	/* invalidate entire I-cache */
	mcr	p15, 0, r0, c7, c5, 0	/* invalidate entire I-cache */
	mcr	p15, 0, r0, c7, c5, 0	/* invalidate entire I-cache */
	msr	cpsr_cx, r1		/* restore interrupts */
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop

	ldmia	sp!, {r0, r1}
	bx	lr
#endif
